// html.cpp
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "dbd.h"

#include "html.h"


void error(char *s)
{
	printf("\n");		// End of http header
	printf("<html><body> <h1>Error</h1> This is the text of the error message: '%s' </body></html>\n",s);
	fflush(stdout);
	exit(-1);
}

void header_top(char *s,long useronline)
{
	printf("<html><head><base target=rf></head>\n");
	printf("<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	if (*s)
		printf("<h3>%s</h3>\n",s);
	if (*errstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ff8080><font size=+1>%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ffff80><font size=+1>%s</font></td></tr></table>\n",warningstr);
}

void header0(char *s,long useronline)
{
	printf("<html><head><base target=rf></head>\n");
	printf("<body>"); // background=/image/dbdinnehall.gif BGPROPERTIES=fixed>\n");
	if (*s)
		printf("<h3>%s</h3>\n",s);
	if (*errstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ff8080><font size=+1>%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ffff80><font size=+1>%s</font></td></tr></table>\n",warningstr);
}


// top header (useronline = 1), login header, new user header

void header(char *s,long useronline)
{
	printf("<html><head><base target=rf>\n");
//	if (*s)
//		printf("<title>%s: %s</title>\n",TITLE,s);
//	else
//		printf("<title>%s</title>\n",TITLE);
	printf("</head>\n");
	printf("<body>"); // bgcolor=#66ddfe>");
	printf("<table width=100%% cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		printf("<h1>%s: %s</h1>\n",TITLE,s);
	else
		printf("<h1>%s</h1>\n",TITLE);
//		printf("<img src=/image/dbdlogo.gif>");
	printf("</td>");
	printf("<td valign=top align=right>");
//	printf("<form action=/cgi-bin/dbd/dbd method=post>");
//	printf("<input type=submit name=logout value=\" Logout \">");
//	printf("</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		printf("[\n");
		if (useronline == 1)
			printf("design\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?design=0>design</a>\n");
		printf("|\n");
		printf("<a href=/cgi-bin/dbd/dbd?ed=0>edit data</a>\n");
		printf("|\n");
		printf("<a href=/cgi-bin/dbd/dbd?sql=1>generate sql</a>\n");
		printf("|\n");
		if (useronline == 2)
			printf("db access\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?dba=0>db access</a>\n");
		printf("|\n");
		if (useronline == 3)
			printf("user info\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?ui=0>user info</a>\n");
		printf("|\n");
		printf("<a target=_top href=/cgi-bin/dbd/dbd?logout=0>logout</a>\n");
		printf("]\n");
		printf("<br>\n");
		printf("[ <a href=/cgi-bin/dbd/dbd?ls=0>live sync</a> ]\n");
	}
	printf("</td></tr></table>\n");
	if (*errstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ff8080><font size=+1>%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ffff80><font size=+1>%s</font></td></tr></table>\n",warningstr);
}

void nullheader(char *s,long useronline)
{
	printf("<html><head>\n");
//	if (*s)
//		printf("<title>%s: %s</title>\n",TITLE,s);
//	else
//		printf("<title>%s</title>\n",TITLE);
	printf("</head>\n");
	printf("<body>"); // bgcolor=#66ddfe>");
	printf("<table width=100%% cellpadding=0 cellspacing=0><tr><td valign=middle>");
	if (*s)
		printf("<h1>%s: %s</h1>\n",TITLE,s);
	else
		printf("<h1>%s</h1>\n",TITLE);
//		printf("<img src=/image/dbdlogo.gif>");
	printf("</td>");
	printf("<td valign=top align=right>");
//	printf("<form action=/cgi-bin/dbd/dbd method=post>");
//	printf("<input type=submit name=logout value=\" Logout \">");
//	printf("</form>");

// useronline = 1 design
//  2 db access
//  3 user info
//  4 -
//  5 edit data
//  6 generate sql
//

	if (useronline)
	{
	useronline = 999;
		printf("[\n");
		if (useronline == 1)
			printf("design\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?design=0>design</a>\n");
		printf("|\n");
		printf("<a href=/cgi-bin/dbd/dbd?ed=0>edit data</a>\n");
		printf("|\n");
		printf("<a href=/cgi-bin/dbd/dbd?sql=1>generate sql</a>\n");
		printf("|\n");
		if (useronline == 2)
			printf("db access\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?dba=0>db access</a>\n");
		printf("|\n");
		if (useronline == 3)
			printf("user info\n");
		else
			printf("<a href=/cgi-bin/dbd/dbd?ui=0>user info</a>\n");
		printf("|\n");
		printf("<a target=_top href=/cgi-bin/dbd/dbd?logout=0>logout</a>\n");
		printf("]\n");
		printf("<br>\n");
		printf("[ <a href=/cgi-bin/dbd/dbd?ls=0>live sync</a> ]\n");
	}
	printf("</td></tr></table>\n");
	if (*errstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ff8080><font size=+1>%s</font></td></tr></table>\n",errstr);
	if (*warningstr)
		printf("<table width=100%%><tr><td align=middle bgcolor=#ffff80><font size=+1>%s</font></td></tr></table>\n",warningstr);
}

void footer(void)
{
	printf("<br><br>[\n");
	printf("<a target=_top href=/cgi-bin/dbd/dbd?repair=0>repair frames</a>\n]<br>\n");
	printf("<br>");
	printf("Enter <a target=bugz href=/bugznf/>Bugs'n Features</a> to report any bugs / suggestions.<br>\n");
//	printf("<br><br>Please send bug reports to <a href=mailto:grymse@telia.com>Grymse</a>.\n");
//	printf("If you have a problem, please make sure that Grymse has access to your database.\n");
	printf("</body></html>\n");
}

// images

void iplus(void)
{
	printf("<IMG SRC='/image/iplus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iplusend(void)
{
	printf("<IMG SRC='/image/iplus-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iexpanded(void)
{
	printf("<IMG SRC='/image/iminus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void inotexpanded(void)
{
	printf("<IMG SRC='/image/iplus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iclosed(void)
{
	printf("<IMG SRC='/image/ifolder-closed-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iminus(void)
{
	printf("<IMG SRC='/image/iminus-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iminusend(void)
{
	printf("<IMG SRC='/image/iminus-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iopen(void)
{
	printf("<IMG SRC='/image/ifolder-open-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ivertline(void)
{
	printf("<IMG SRC='/image/ivert-line-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ibranchcont(void)
{
	printf("<IMG SRC='/image/ibranch-cont-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP border=0>");
}

void ibranchend(void)
{
	printf("<IMG SRC='/image/ibranch-end-0.gif' WIDTH=19 HEIGHT=16 ALIGN=TEXTTOP border=0>");
}

void iglobe(void)
{
	printf("<IMG SRC='/image/globe.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iglobe0(void)
{
	printf("<IMG SRC='/image/iglobe-0.gif' WIDTH=16 HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ithumbsup(void)
{
	printf("<IMG SRC='/image/thumbsup2.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ithumbsdown(void)
{
	printf("<IMG SRC='/image/thumbsdn2.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void ipascal(void)
{
	printf("<IMG SRC='/image/pascal.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}

void iempty(void)
{
	printf("<IMG SRC='/image/iempty.gif' HEIGHT=16 ALIGN=TEXTTOP BORDER=0>");
}
