// utils.h
/*
Copyright (C) 2001-2004  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _UTILS_H
#define _UTILS_H

#include <stdlib.h>
#include <mysql/mysql.h>
#include <Query.h>
#include <libdbd.h>
#include <string>
using std::string;
#include <libcgi++.h>


void zap(char *,char);
char *fget(char *,int,FILE *);
char *datetime(void);
char *expiredatetime(void);
void textareain(char *);
void strlwr(char *);
void set_cookie(Cookies *cs,char *n,char *v);
void set_cookie(Cookies *cs,char *n,long v);
long reg_valid(Database *db,long num);
void showuser(Users *user);
void showuser(Database *db,long num);
void dbsafestr2(char *s);
void strupr(char *s);
int syscall(char *s);
int name_ok(char *);
void remove_br(char *s);

#endif // _UTILS_H
